#!/bin/sh
echo "----------------------------------------------------------------------"
echo "-----------------------    build u-boot   ---------------------------"
echo "----------------------------------------------------------------------"

if [ -e sysconfig.sh ]; then
	. sysconfig.sh
else
	echo "Application "$APPS_NAME" not configured"
	exit 1;
fi

parse_args $@

if [ $BUILD_CLEAN -eq 1 ]; then
	rm -f .config_ok
	make distclean
	[ $BUILD_CONFIGURE -ne 1 ] && exit 0
fi

if [ $BUILD_CONFIGURE -eq 1 -o ! -f .config_ok ] ;then
	make incaip2_config
	echo -n > .config_ok
fi

make KERNEL_INCL=$KERNEL_SOURCE_DIR/include CODE_MEMORY_LOCATION=ram ld_uboot.img

cp ld_uboot.img "$BUILD_DIR"

${IFX_STRIP} ./tools/env/fw_printenv
#${IFX_STRIP} extr_kernel
install -d ${OUTPUT_BUILD_DIR}/root_filesystem/sbin/
#cp -f extr_kernel ${OUTPUT_BUILD_DIR}/root_filesystem/sbin/
cp -f ./tools/env/fw_printenv ${OUTPUT_BUILD_DIR}/root_filesystem/sbin/
install -d ${OUTPUT_BUILD_DIR}/root_filesystem/etc/
cp -f ./tools/env/fw_env.config ${OUTPUT_BUILD_DIR}/root_filesystem/etc/
#cd ${OUTPUT_BUILD_DIR}/root_filesystem/sbin/
#rm fw_setenv
#ln -s fw_printenv fw_setenv
#ifx_error_check $?
