/*
 * (C) Copyright 2003-2005
 * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

/*
 * This file contains the configuration parameters for the INCA-IP board.
 */

#ifndef __CONFIG_H
#define __CONFIG_H

#define CONFIG_MIPS32		1	/* MIPS 4Kc CPU core	*/
#define CONFIG_INCA_IP		1	/* on a INCA-IP Board	*/

#undef CONFIG_DISPLAY
//#undef DEBUG
#define DEBUG

#define CFG_INCA_ALLTEK 
#undef CFG_INCA_ALLTEK 
#define CFG_INCA_FLEXTRONICS
#undef CFG_INCA_FLEXTRONICS 


#ifndef	CPU_CLOCK_RATE
/* allowed values: 100000000, 133000000, and 150000000 */
#define CPU_CLOCK_RATE	150000000	/* default: 150 MHz clock for the MIPS core */
#endif

#define INFINEON_EBU_BOOTCFG	0x40C4	/* CMULT = 8 */

#define CONFIG_BOOTDELAY	5	/* autoboot after 5 seconds	*/

#define CONFIG_BAUDRATE		115200

/* valid baudrates */
#define CFG_BAUDRATE_TABLE	{ 9600, 19200, 38400, 57600, 115200 }

#define	CONFIG_TIMESTAMP		/* Print image info with timestamp */

#define CONFIG_PREBOOT	"echo;"	\
	"echo Type \"run flash_nfs\" to mount root filesystem over NFS;" \
	"echo"

#undef	CONFIG_BOOTARGS

#define	CONFIG_EXTRA_ENV_SETTINGS					\
	"nfsargs=setenv bootargs root=/dev/nfs rw "			\
		"nfsroot=$(serverip):$(rootpath)\0"			\
	"ramargs=setenv bootargs root=/dev/ram rw\0"			\
	"addip=setenv bootargs $(bootargs) "				\
		"ip=$(ipaddr):$(serverip):$(gatewayip):$(netmask)"	\
		":$(hostname):$(netdev):off\0"				\
	"addmisc=setenv bootargs $(bootargs) "				\
		"console=ttyS0,$(baudrate) "				\
		"ethaddr=$(ethaddr) "					\
		"panic=1\0"						\
	"flash_nfs=run nfsargs addip addmisc;"				\
		"bootm $(kernel_addr)\0"				\
	"flash_self=run ramargs addip addmisc;"				\
		"bootm $(kernel_addr) $(ramdisk_addr)\0"		\
	"net_nfs=tftp 80500000 $(bootfile);"				\
		"run nfsargs addip addmisc;bootm\0"			\
	"rootpath=/opt/eldk/mips_4KC\0"					\
	"bootfile=uImage\0"						\
	"kernel_addr=B0050000\0"					\
	"ramdisk_addr=B0110000\0"					\
	"u-boot=u-boot.bin\0"						\
	"loadloader=tftp 80500000 $(u-boot)\0"				\
	"updloader=protect off 1:0-6;era 1:0-6;"			\
		"cp.b 80500000 B0000000 $(filesize)\0"			\
	"loadkernel=tftp 80400000 $(bootfile)\0"			\
	"updkernel=era b0040000 b00fffff;"				\
		"cp.b 80400000 B0040000 $(filesize)\0"			\
	"vxargs=setenv loadaddr 0x80400000;setenv bootaddr 0x80000700;"	\
		"setenv bootargs sw(0,0)host:vxWorks e=$(ipaddr)"	\
		" h=$(serverip) u=username pw=userpw f=2 tn=inca\0"	\
	"net_vxworks=run vxargs;tftp $(loadaddr) vxWorks;bootvx\0"	\
	"flash_all=run jffs2args addip addmisc;" \
		"fsload 80400000 /boot/uImage;" \
		"bootm 80400000\0" \
	"factoryargs=setenv bootargs root=/dev/mtdblock3 rw rootfstype=jffs2\0" \
	"factory_system=run factoryargs addip addmisc;" \
		"bootm $(kernel_addr)\0" \
	"failsave=setenv bootcmd run factory_system;saveenv;run factory_system\0" \
	"reset_env=protect off b0050000 b005ffff;erase b0050000 b005ffff\0" \
	"dhcp=off\0" \
        "ipaddr=190.16.20.234\0"                                        \
        "serverip=190.16.7.101\0"                                       \
        "ethaddr=08:00:06:2b:97:a1\0"                                   \
        "nand_flash_all=run nandjffs2args addip addmisc; fsload 80800000 /boot/uImage; "        \
                "bootm 80800000\0"                                      \
        "updatefs=nand erase clean 200000 400000;mw.b 80500000 ff 400000;tftp 80500000 rootfs.inca.img;" \
                "nand write.jffs2 80500000 200000 $(filesize)\0" \
        "nandjffs2args=setenv bootargs root=/dev/mtdblock0 rw rootfstype=jffs2\0"          \
	""

#define CONFIG_BOOTCOMMAND      "run nand_flash_all"


#define CONFIG_COMMANDS	       (CONFIG_CMD_DFL	| \
				CFG_CMD_ASKENV	| \
				CFG_CMD_DHCP	| \
				CFG_CMD_ELF	| \
				CFG_CMD_NAND	| \
				CFG_CMD_JFFS2	| \
				CFG_CMD_NFS	| \
				CFG_CMD_PING	| \
				CFG_CMD_SNTP	)
#include <cmd_confdefs.h>

/*
 * Miscellaneous configurable options
 */
#define	CFG_LONGHELP				/* undef to save memory      */
#if TEXT_BASE == 0xb0000000
#define	CFG_PROMPT		"INCA-IP-ROM # "	/* Monitor Command Prompt    */
#else
#define	CFG_PROMPT		"INCA-IP-RAM # "	/* Monitor Command Prompt    */
#endif

#define	CFG_CBSIZE		256		/* Console I/O Buffer Size   */
#define	CFG_PBSIZE (CFG_CBSIZE+sizeof(CFG_PROMPT)+16)  /* Print Buffer Size */
#define	CFG_MAXARGS		16		/* max number of command args*/

#define CFG_MALLOC_LEN		128*1024

#define CFG_BOOTPARAMS_LEN	128*1024

#define CFG_HZ			(incaip_get_cpuclk() / 2)

#define CFG_SDRAM_BASE		0x80000000

#define	CFG_LOAD_ADDR		0x80100000	/* default load address	*/

#define CFG_MEMTEST_START	0x80100000
#define CFG_MEMTEST_END		0x80800000

/*-----------------------------------------------------------------------
 * FLASH and environment organization
 */
#ifdef CFG_INCA_ALLTEK
#define CFG_MAX_FLASH_BANKS	1	/* max number of memory banks */
#define CFG_MAX_FLASH_SECT	(256)	/* max number of sectors on one chip */
#else
#ifdef CFG_INCA_FLEXTRONICS
#define CFG_MAX_FLASH_BANKS	1	/* max number of memory banks */
#define CFG_MAX_FLASH_SECT	(128)	/* max number of sectors on one chip */
#else
#define CFG_MAX_FLASH_BANKS	2	/* max number of memory banks */
#define CFG_MAX_FLASH_SECT	(128)	/* max number of sectors on one chip */
#endif /* CFG_INCA_FLEXTRONICS */
#endif /* CFG_INCA_ALLTEK */

#define PHYS_FLASH_1		0xb0000000 /* Flash Bank #1 */
#define PHYS_FLASH_2		0xb0800000 /* Flash Bank #2 */

/* The following #defines are needed to get flash environment right */
#define	CFG_MONITOR_BASE	TEXT_BASE
#define	CFG_MONITOR_LEN		(192 << 10)

#define CFG_INIT_SP_OFFSET	0x400000

#define CFG_FLASH_BASE		PHYS_FLASH_1

/* timeout values are in ticks */
#define CFG_FLASH_ERASE_TOUT	(20*2 * CFG_HZ) /* Timeout for Flash Erase */
#define CFG_FLASH_WRITE_TOUT	(2 * CFG_HZ) /* Timeout for Flash Write */

#define	CFG_ENV_IS_IN_FLASH	1

#define CFG_ETHERNET_MAC_ADDR 	0xb0ff00f0
#define CFG_ETHERNET_MAC_SECT 	0xb0ff0000

/* Address and size of Primary Environment Sector	*/
#define CFG_ENV_ADDR		0xB0050000
#define CFG_ENV_SIZE		0x10000

#define CONFIG_FLASH_16BIT

#define CONFIG_NR_DRAM_BANKS	1

#define CONFIG_INCA_IP_SWITCH
#define CONFIG_NET_MULTI
#undef INCAIP_AUTO_MDIX
#define CONFIG_INCA_IP_SWITCH_AMDIX
#undef CONFIG_INCA_IP_SWITCH_AMDIX


//#define CFG_JFFS2_FIRST_BANK	1  // winder add
//#define CFG_JFFS2_NUM_BANKS	1
//#define CFG_JFFS_CUSTOM_PART

/*-----------------------------------------------------------------------
 * Cache Configuration
 */
#define CFG_DCACHE_SIZE		4096
#define CFG_ICACHE_SIZE		4096
#define CFG_CACHELINE_SIZE	16

/**********************************************************
 * NAND FLASH support. (OPTION) 
  * You can boot from NAND or NOR flash if the incaip board support it.
  */
//#define NEW_VERSION_NAND_SUPPORT 1   // for Large Page nand and some new features of nand.
#define CFG_NAND_BASE		0xB1000000 //start address
#define CONFIG_MTD_NAND_VERIFY_WRITE
#define CONFIG_MTD_NAND_UNSAFE
#define CONFIG_MTD_NAND_ECC
#define CONFIG_MTD_NAND_ECC_JFFS2

//#define CFG_ENV_IS_IN_NAND 1
//#define CFG_ENV_OFFSET 0x80000

#define CONFIG_JFFS2_NAND	1			/* jffs2 on nand support */
#define CONFIG_JFFS2_NAND_DEV	0			/* nand device jffs2 lives on */
#define CONFIG_JFFS2_NAND_OFF	(2 * 1024 * 1024)	/* start of jffs2 partition */
#define CONFIG_JFFS2_NAND_SIZE	(4*1024*1024)		/* size of jffs2 partition */

#define CFG_MAX_NAND_DEVICE		1
/* #define NAND_NO_RB */

#define SECTORSIZE		512
#define ADDR_COLUMN		1
#define ADDR_PAGE		2
#define ADDR_COLUMN_PAGE	3
#define NAND_ChipID_UNKNOWN 	0x00
#define NAND_MAX_FLOORS		1
#define NAND_MAX_CHIPS		1

#undef NAND_DEBUG
//#define NAND_DEBUG 1

/** NAND FLASH define END **********************************/


#endif	/* __CONFIG_H */
