#ifndef __DISPLAY_H__
#define __DISPLAY_H__

#define DISPLAY_SIZE	80	/* 80 characters */
#define DISPLAY_TIMEOUT	1000
#define DISPLAY_CHIPSELECT_0	*INCA_IP_Ports_P2_OUT &= ~(1 << 15);
#define DISPLAY_CHIPSELECT_1	*INCA_IP_Ports_P2_OUT |= (1 << 15);

#define DISPLAY_LEFT		0
#define DISPLAY_RIGHT		1
#define DISPLAY_HOME		2
#define DISPLAY_NEXTLINE	3
#define DISPLAY_ROWHOME		4

#define WAIT_TIMEOUT	100000

enum {
	PWM1,
	PWM2
};

enum
{
	CURSOR_OFF,
	CURSOR_ON
};

enum 
{
	COMMAND,      /* read from or write to command register */
	DATA          /* read from or write to data register */
};

extern int display_init(void);
extern int display_clear(void);
extern int display_cleanup(void);
extern int display_print(char *data);
extern int display_printf(char *data, int i_value);
extern int display_goto(int option);
extern int display_cursor_show(int option);
extern int display_scroll(void);
extern int display_clear_line(void);

extern int display_write(int cmd_data, unsigned char value);
extern int display_read(int cmd_data, unsigned char *value);
extern int display_wait(void); 

extern unsigned char maplcdchar(unsigned char c_char);
extern unsigned char mapfromlcd(unsigned char uc_value);

/* PWM functions */
extern int pwm_init(void);
extern int pwm_close(void);
extern int pwm_set(int id, unsigned int uc_duty_cycle_val);

#endif
